<?php

class LASTResampler extends RESAMPLER {
  var $max_gap;

  function __construct(REQUEST $req  = NULL, $opts = false, $sampling = false) {
    parent::__construct($req, $opts, $sampling);

    $this->max_gap = $this->GetOption('max_gap', 0);
  }

  function Resample($data, $flags = 0) {
    $nchan = $this->GetNumberOfChannels($data);

    $out = array(
	'info' => $data['info'],
	'data' => array()
    );

    $keys = array_keys($data['data']);
	// Keys from different channels can be added sequentially not chronologically
    sort($keys, SORT_NUMERIC);
    $src = &$data['data'];

    $filtered = 0;
    for ($i = 0; $i < sizeof($keys); $i++) {
        $vout = array();
	$outkey = $keys[$i];
        for ($ch = 0; $ch < $nchan; $ch++) {
	    for ($j = $i; $j >=0; $j--) {
		$key = $keys[$j];

	    	if (($this->max_gap)&&(($outkey - $key) > $this->max_gap)) {
	    	    $j = -1;
	    	    break;
	    	}

	        if (is_numeric($src[$key][$ch])) {
		    $vout[$ch] = $src[$key][$ch];
		    break;
		}
	    }
	    if ($j < 0) break;
	}
	
	if (sizeof($vout) == $nchan) {
	    $out['data'][$outkey] = $vout;
	} else {
	    $filtered++;
	}
    }

    $out['info']['incomplete'] = $filtered;
    return $out;
  }
}

?>